'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = mount;

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _vueAddGlobals = require('vue-add-globals');

var _vueAddGlobals2 = _interopRequireDefault(_vueAddGlobals);

var _lodash = require('lodash');

var _VueWrapper = require('./VueWrapper');

var _VueWrapper2 = _interopRequireDefault(_VueWrapper);

require('./lib/matchesPolyfill');

var _addSlots = require('./lib/addSlots');

var _addSlots2 = _interopRequireDefault(_addSlots);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_vue2.default.config.productionTip = false;

function createElem() {
  var elem = document.createElement('div');

  document.body.appendChild(elem);

  return elem;
}

function mount(component) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var elem = null;
  var attachToDocument = options.attachToDocument;

  if (attachToDocument) {
    elem = createElem();
    delete options.attachToDocument;
  }

  delete component._Ctor;

  if (options.context) {
    (function () {
      if (!component.functional) {
        throw new Error('mount.context can only be used when mounting a functional component');
      }

      if (_typeof(options.context) !== 'object') {
        throw new Error('mount.context must be an object');
      }
      var clonedComponent = (0, _lodash.cloneDeep)(component);
      component = {
        render: function render(h) {
          return h(clonedComponent, options.context);
        }
      };
    })();
  }
  var Constructor = void 0;

  if (options.instance) {
    Constructor = options.instance.extend(component);
  } else {
    Constructor = _vue2.default.extend(component);
  }

  if (options.globals) {
    var globals = (0, _vueAddGlobals2.default)(options.globals);
    Constructor.use(globals);
  }
  var vm = new Constructor(options);

  if (options.slots) {
    (0, _addSlots2.default)(vm, options.slots);
  }

  vm.$mount(elem);

  return new _VueWrapper2.default(vm, attachToDocument);
}